# Elektra API Review

This folder contains all API design reviews conducted on LibElektra.
Below you can find a short description of the review process.

## Review Process

This review is performed for each function separately. Each function should be
evaluated according to the checklist. The reviewer judges for every bullet
point, whether the function does / does not fulfill the bullet point. For
every unfulfilled point a short explanation has to be given why the reviewer
thinks the function does not fulfill the respective bullet point. This is done
simply by providing a short description of the issue below the respective
bullet point. After the review has been completed, the reviewer creates an
issue for every unfulfilled bullet point so it can be fixed by the Elektra Initiative.

## Checklist Legend

- [ ] not fulfilled  
       This is the reason for why its is not fulfilled
- [x] fulfilled
- not applicable

## Templates

The template and the script for generating review files based on that template
can be found [here](/scripts/api_review/README.md)
